package main

import (
	"fmt"
	"log"

	httpserver "git.aetherial.dev/aeth/http-proxy/pkg"
	"github.com/gin-contrib/cors"
	"github.com/gin-gonic/gin"
)

func main() {
	cfg, err := httpserver.ReadConfig("./.config.json")
	if err != nil {
		log.Fatal("Couldnt read config: ", err)
	}

	e := gin.Default()
	config := cors.DefaultConfig()
	config.AllowOrigins = []string{
		"https://semrush.com",
		"https://static.semrush.com",
		"https://sem.bunnytool.shop",
	}
	e.Use(cors.New(config))
	rmaps := httpserver.PopulateRouteMaps(cfg.RouteMapDir)
	fmt.Printf("%v\n", rmaps["static.semrush.com"])
	httpserver.RegisterRoutes(e, cfg, rmaps)
	e.RunTLS(fmt.Sprintf("%s:%v", "0.0.0.0", cfg.HttpsPort), "/etc/letsencrypt/live/void-society.online/fullchain.pem", "/etc/letsencrypt/live/void-society.online/privkey.pem")

}
